package dk.nsp.idsas.ws;

import org.springframework.context.annotation.AnnotationConfigApplicationContext;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;

import static dk.nsp.idsas.setup.ServiceSetup.ANNOTATION_CONFIG_CONTEXT;

public abstract class AbstractServlet extends HttpServlet {
	@Override
	public void init(ServletConfig config) throws ServletException {
		super.init(config);

		// Her er formålet ganske enkelt at sikre, at man kan bruge @Autowired i servlets, da
		// de jo ikke er managed af Spring.
		Object o = getServletContext().getAttribute(ANNOTATION_CONFIG_CONTEXT);
		((AnnotationConfigApplicationContext) o).getAutowireCapableBeanFactory().autowireBean(this);
	}
}
