package dk.nsp.idsas.test.idptest;

public enum SOAPOperation {
    CreateBlurring(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/",
            "CreateBlurring",
            "CreateBlurringRequest"),

    GetSalt(
            "http://sundhedsdatastyrelsen.dk/identitetssloering/2023/06/01/",
            "GetSalt",
            "GetSaltRequest");


    private final String soapNamespace;
    private final String soapOperation;
    private final String rootElement;

    private SOAPOperation(String soapNamespace, String soapOperation, String rootElement) {
        this.soapNamespace = soapNamespace;
        this.soapOperation = soapOperation;
        this.rootElement = rootElement;
    }

    public String getSoapNamespace() {
        return soapNamespace;
    }

    public String getSoapOperation() {
        return soapOperation;
    }

    public String getRootElement() {
        return rootElement;
    }
}